#ifndef CHAR_GENERATOR_FACTORY_HPP
#define CHAR_GENERATOR_FACTORY_HPP

#include "../core/char_generator.hpp"

#include <vector>
#include <string>
#include <map>

class CharGeneratorFactory
{
public:
    CharGeneratorFactory();

    std::vector<std::string> getCharGeneratorNames() const;

    CharGeneratorPtr getGenerator(const std::string name) const;

    CharGeneratorPtr front() const;

private:
    bool insert(std::string name, CharGeneratorPtr);

    std::map<std::string, CharGeneratorPtr> charGeneratorsMap_;
};

#endif // CHAR_GENERATOR_FACTORY_HPP
