#include "password_generator.hpp"

PasswordGenerator::PasswordGenerator(CharGeneratorPtr charGenerator)
    : charGenerator_(charGenerator)
{
}

void PasswordGenerator::set(CharGeneratorPtr charGenerator)
{
    charGenerator_ = charGenerator;
}

Password PasswordGenerator::generate(size_t length) const
{
    std::string password(length, 'a');

    for (auto &ch : password)
    {
        ch = charGenerator_->generate();
    }

    return password;
}

Password::Password(std::string password)
    : password_(password)
{}

std::string Password::get() const
{
    return password_;
}
